(function()
{
 "use strict";
 /*
   hook up event handlers 
 */
 function register_event_handlers()
 {
         $(document).on("click", "#btnSendAnswer", function(evt)
        {
            if (txtCaptchaAnswer.value=="") alert("Please enter answer!");
            else{
                sendAnswer(1);
            }
        });    
     
     document.addEventListener("intel.xdk.device.orientation.change",OnOrientationchange,false); 
     
     
     init();
     
     updateCredits();
     
        $(document).on("click", "#btnStart", function(evt)
        {
            //alert("starting to solve");
            var username = $("#txtUsername").val();                    
            var password = $("#txtPassword").val();

            if (username==="" || password===""){
                alert("Please fill in username and password fields on Credentials tab!");
                return;
            }
            
            //alert($("#txtUsername").val());
            if(typeof(Storage) !== "undefined") {
                //alert(localStorage.getItem("cbhUsername"));
                localStorage.setItem("cbhUsername",$("#txtUsername").val());
                localStorage.setItem("cbhPassword",$("#txtPassword").val());
            } else {
                // Sorry! No Web Storage support..
            }
            
            //toggleMode("Asking");
            stopAskCaptcha = false;
            setTimeout(askCaptcha, 100); // ilk starta bastığında hemen sormaya başlasın
        });
        $(document).on("click", "#btnStop", function(evt)
        {
            toggleMode("Initial");
        });
     
        $('#txtCaptchaAnswer').keypress(function(event) {
        if (event.keyCode == 13) {
            sendAnswer(1);
        }
    });
     
     
}
    
    function OnOrientationchange(value){
        console.log(value.orientation);
    }
    
    function updateCredits(){
        $.ajax({
                url: 'http://www.captchabrotherhood.com/askCredits.aspx?username=' + txtUsername.value + '&password=' + txtPassword.value,
                type: 'GET',
                dataType: 'text',
                success: function (data) { //OK-1234
                    // sormaya devam
                    //$('#txtCredits').text('Credits : '+data.split('-')[1]);            
                    $('#txtCredits').text('Credits : '+data.split('-')[1]);            
                },
                error: function (data) {
                    alert('error');
                }
            });
        
        
        
    }
        
    function sendAnswer(continueAsking) {
            $.ajax({
                url: 'http://www.captchabrotherhood.com/setcaptchaResult.aspx?username=' + txtUsername.value + '&password=' + txtPassword.value + '&captchaID=' + currentCaptchaId + '&captchaAnswer=' + txtCaptchaAnswer.value + '&version=9.9.9',
                type: 'GET',
                dataType: 'text',
                success: function (data) {
                    // sormaya devam
                    if (continueAsking===1){
                        toggleMode("Asking");
                        setTimeout(askCaptcha, 3000);
                    }
                    
                    updateCredits();
                },
                error: function (data) {
                    alert('error');
                }
            });
        }
    
    function solveTimeout(){
        
        if (stopTimeout) return;
        timeOutRemaining-=1;
        document.getElementById("countDown").innerHTML=timeOutRemaining+" / 30 seconds";
        
        if (timeOutRemaining<10){
            $("#countDown").css("color","red");
        }
        else{
            $("#countDown").css("color","black");
        }
        
        if (timeOutRemaining<0){
            alert ("you timed out!");            
            sendAnswer(0);                        
            toggleMode("Initial");
        }
        else{
            setTimeout(solveTimeout, 1000);
        }
    }
    
    var timeOutRemaining=30;
    
    function askCaptcha() {

            //vatandaş stop a bastıysa askCaptcha yı hiç başlatma
            if (stopAskCaptcha) return;

            toggleMode("Asking");
            var requestURL='http://www.captchabrotherhood.com/getCaptcha2Solve.aspx?username=' + txtUsername.value + '&password=' + txtPassword.value+'&version=9.9.9&NoConfirmation=true';
            $.ajax({
                url: requestURL,
                type: 'GET',
                dataType: 'text',
                success: function (data) {
                    var parts = data.split('-');
                    if (parts[0] == 'OK') {
                        if (parts[1] != 'No Captcha') {
                            toggleMode("Solving");
                            currentCaptchaId = parts[1];
                            $("#imgCaptcha").attr("src", "http://www.captchabrotherhood.com/showcaptcha.aspx?captchaID=" + currentCaptchaId+"&username="+txtUsername.value+"&password="+txtPassword.value);                            
                            navigator.notification.beep(1);
                        }
                        else {
                            if (!stopAskCaptcha)
                                setTimeout(askCaptcha, 3000);
                        }
                    }
                    else if (parts[0]=='Error'){
                        if (parts[1]=='User Error'){
                            alert('Invalid Credentials');
                            toggleMode('Initial');
                        }
                    }
                },
                error: function (data) {
                    alert('error'+data);
                }
            });
    
        }
    
    function onSoundComplete(){}
    
    function toggleMode(mode){
        if (mode==="Initial"){
            
            $("#divAsking").hide();            
            $("#divSolving").hide();            
            $("#divInitial").show();
            
            $("#countDown").hide();
            $("#txtCaptchaAnswer").val('');
            $("#imgCaptcha").hide();
            
            stopAskCaptcha = true;            
            stopTimeout=true;
        }
        else if (mode==="Asking"){                
            
            $("#divAsking").show();            
            $("#divSolving").hide();            
            $("#divInitial").hide();
            
            $("#countDown").hide();            
            $("#txtCaptchaAnswer").val('');            
                
            stopTimeout=true;
            stopAskCaptcha = false;            
            
        }
        else if (mode==="Solving"){
                
            $("#divAsking").hide();            
            $("#divSolving").show();            
            $("#divInitial").hide();            
            
            $("#countDown").show();            
            $("#imgCaptcha").show();
            
            timeOutRemaining=30;
            
            stopTimeout=false;
            stopAskCaptcha = true;            
            
            setTimeout(solveTimeout,1000);
        }
    }
 $(document).ready(register_event_handlers);
    
function init()
    {
        toggleMode("Initial");
            $("#tabCredentials")
            .on("collapsiblecollapse",function(e){                    
                }
               );
        
        if(typeof(Storage) !== "undefined") {
            //alert(localStorage.getItem("cbhUsername"));
            if (localStorage.getItem("cbhUsername")!=null){
                $("#txtUsername").val(localStorage.getItem("cbhUsername"));
            }
            if (localStorage.getItem("cbhPassword")!=null){
                $("#txtPassword").val(localStorage.getItem("cbhPassword"));
            }
        } else {
            // Sorry! No Web Storage support..
        }
    }
})();
